function [ L, U, P, y ] = fatt_LU( A )
% A viene passata come matrice completa [A b]
[n,nc] = size(A);
%inizializzo le matrici
U = zeros(n);
P = eye(n);

[n,m] = size(A);
P = eye(n);
for k = 1:n-1
    
    % ricerca pivot massimo per righe
    [piv,r] = max(abs(A(k:n,k)));
    r = r + k - 1;
    % scambio righe k con r 
    A([k r],:)=A([r,k],:);
    P([k r],:)=P([r,k],:);

%    if abs(A(k,k)) not= realmin
%        error('La matrice in input ha un elemento pivotale piccolo')
%    end
    % Calcolo moltiplicatori matrice elementare di Gauss
    A(k+1:n,k)= A(k+1:n,k)/A(k,k);
    % Aggiornamento A_k
    A(k+1:n,k+1:m)=A(k+1:n,k+1:m) - A(k+1:n,k)*A(k,k+1:m);
end

y = A(:,nc);  
U = triu(A(1:n,1:n));
L = tril(A(1:n,1:n),-1) + eye(n);
              
end
% NOTA: la costruzione della matrice L avviene memorizzando i
% moltiplicatori m_ik nelle corrispondenti posizioni A_ik
% non e' necessario memorizzare un'ulteriore matrice L
% per ottenere L e' sufficiente che ogni volta che si scambiano due righe
% di A tale scambio venga effettuato anche sui moltiplicatori memorizzati
% su tali righe
